/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package metier;

import java.util.Vector;

/**
 *
 * @author mohamed.boussemaha
 */
public class Jeu {
    /*****Attributs*****/
    private final String nomJeu;
    private Personnage[] lesPersonnages;

    /*****Constructeur*****/
    public Jeu(String nomJeu) {
        this.nomJeu = nomJeu;
        this.chargerLesPersonnages();         
    }

    /*****Accesseur*****/
    public String getNomJeu() {
        return this.nomJeu;
    }

    /**
     *
     * @return
     */
    public Personnage[] getLesPersonnages() {
        return this.lesPersonnages;
    }

    /*****Mutateurs*****/
    
    /**
     * 
     * @param lesPersonnages 
     */
    public void setLesPersonnages(Personnage[] lesPersonnages) {
        this.lesPersonnages = lesPersonnages;
    }

    /*****Mthodes*****/
    private void chargerLesPersonnages() {
        Enigme[] enigmes1 = {
            new Enigme("Qu?est ce qui est plus grand que la Tour Eiffel, mais infiniment moins lourd ?", "ombre"),
            new Enigme("Girafe = 3, lphant = 3, Hippopotame = 5, Lion = ? ?", "2"),
            new Enigme("Qu'est-ce qui commence la nuit et termine le matin ?", "n"),
            new Enigme("Qu'est-ce qui fait le tour de la maison sans bouger ?", "mur")
        };

        Enigme[] enigmes2 = {
            new Enigme("Considrez la suite de chiffre suivante : 0 1 1 2 3 5 8 Quel chiffre suit le 8 ?", "13"),
            new Enigme("Prenez une pizza et placez-la devant vous. En combien de morceaux maximum pouvez-vous la couper en effectuant seulement six coups de couteau ?", "16"),
            new Enigme("C'est le jour de la paie. La poule reoit 7 euros. L'abeille reoit 21 euros. L'araigne reoit 28 euros. Combien reoit le chien ?", "14"),
            new Enigme("Un escargot est au fond d'un puits de 10 mtres. Chaque matin il monte de 3 mtres et chaque nuit il descend de 2 mtres. Combien de jours lui faudra-t-il pour sortir de ce puits ?", "7")
        };

        Sorcier sorcier1 = new Sorcier("Merlin", "merlin.png", 5, 10, "Baguette de chne", 10);
        for (Enigme e : enigmes1) {
            sorcier1.ajouterEnigme(e);
        }

        Sorcier sorcier2 = new Sorcier("Gandalf", "gandalf.png", 5, 10, "Baguette d'if", 10);
        for (Enigme e : enigmes2) {
            sorcier2.ajouterEnigme(e);
        }

        Guerrier guerrier1 = new Guerrier("Guerrier 1", "Guerrier05.jpg", 5, 10, "couteau");
        Voleur voleur1 = new Voleur("Voleur 1", "imgVoleur1", 5, 10, "crochet");

        this.lesPersonnages = new Personnage[4];
        this.lesPersonnages[0] = guerrier1;
        this.lesPersonnages[1] = voleur1;
        this.lesPersonnages[2] = sorcier1;
        this.lesPersonnages[3] = sorcier2;

        for (Personnage personnage : this.lesPersonnages) {
            System.out.println(personnage);  // Affiche le sorcier avec le nombre d'nigmes
        }
    }

    /**
     * 
     * @return 
     */
    public Personnage rechercherPerso(String nom) {
        boolean trouve = false;
        int i = 0;
        while (!trouve && i < lesPersonnages.length) {
            if (lesPersonnages[i].getNom().equals(nom)) {
                trouve = true;
            } else {
                i++;
            }
        }
        return lesPersonnages[i];
    }

    /**
     * 
     * @return 
     */
    public Vector getLesPersonnagesVivants() {
        Vector personnageVivant = new Vector();
        for (Personnage p : lesPersonnages) {
            if (p.getDureeVie() > 0) {
                personnageVivant.add(p.getClass().getSimpleName() + ": " + p.getNom());
            }
        }
        return personnageVivant;
    }

    /**
     *
     * @return
     */
    @Override
    public String toString() {
        String affichage = "";
        for (Personnage personnage : this.lesPersonnages) {
            affichage += personnage + "\n";
        }
        return affichage;
    }

    public static int genererNbAleatoire(int min, int max) {
        return min + (int)(Math.random() * ((max - min) + 1));
    }
}