package metier;

import java.util.Objects;
import java.util.Random;
import javax.swing.JOptionPane;

/**
 *
 * @author Dominique_2
 */
public class Sorcier extends Personnage {
    
    private String baguette;
    private Enigme[] enigmes;
    private int nbEnigmes;
    
    public Sorcier(String nom, String img, int energie, int dureeVie, String baguette, int par2) {
        super(nom, img, energie, dureeVie);
        this.baguette = baguette;
        int tailleMaxEnigmes = 0;
        this.enigmes = new Enigme[tailleMaxEnigmes];
        this.nbEnigmes = 0;
    }
    
    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), baguette, enigmes, nbEnigmes);
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null || getClass() != obj.getClass()) {
            return false;
        }
        Sorcier other = (Sorcier) obj;
        return super.equals(obj) && Objects.equals(baguette, other.baguette) && nbEnigmes == other.nbEnigmes;
    }
    
    @Override
    public String toString() {
        return super.toString() + "\tBaguette=" + baguette + "\nNb Enigmes=" + nbEnigmes;
    }
    
    public Enigme[] getEnigmes() {
        return enigmes;
    }
    
    public void ajouterEnigme(Enigme e) {
        if (nbEnigmes < enigmes.length) {
            enigmes[nbEnigmes] = e;
            nbEnigmes++;
        } else {
            System.out.println("Impossible d'ajouter une nigme. Le tableau est plein.");
        }
    }
    
    @Override
    public String saluer(Personnage unPerso) {
        String titre = this.getNom() + " saluer " + unPerso.getNom();
        String message = "Bonjour " + unPerso.getNom() + ", je t'ai jet un sort, tu es dsormais sous ma dpendance !";
        JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE);
        return message;
    }
    
    @Override
    public String rencontrer(Personnage unPerso) {
        if (nbEnigmes == 0) {
            JOptionPane.showMessageDialog(null, "Je n'ai pas d'nigmes  te poser...", "Sorcier " + this.getNom(), JOptionPane.INFORMATION_MESSAGE);
            return "";
        }
        
        Random rand = new Random();
        Enigme enigme = enigmes[rand.nextInt(nbEnigmes)];
        
        String reponseUtilisateur = JOptionPane.showInputDialog(null, enigme.getQuestion(), "Rpondez  l'nigme", JOptionPane.QUESTION_MESSAGE);
        
        if (reponseUtilisateur != null && reponseUtilisateur.equalsIgnoreCase(enigme.getReponse())) {
            JOptionPane.showMessageDialog(null, "Bonne rponse !", "Sorcier " + this.getNom(), JOptionPane.INFORMATION_MESSAGE);
        } else {
            JOptionPane.showMessageDialog(null, "Mauvaise rponse ! La bonne rponse tait : " + enigme.getReponse(), "Sorcier " + this.getNom(), JOptionPane.INFORMATION_MESSAGE);
        }
        return null;
    }
}